﻿package  
{
	import com.pblabs.components.basic.HealthComponent;
	import com.pblabs.engine.entity.EntityComponent;
	import com.pblabs.engine.entity.PropertyReference;
	import com.pblabs.engine.components.ThinkingComponent;
	import com.pblabs.engine.PBE;
	
	import flash.events.Event;
	import flash.geom.Point;
	
	/**
	 * ...
	 * @author Jesse James Lord
	 */
	public class PawnDeathHandler extends EntityComponent
	{
		public var PositionReference:PropertyReference = null;
		
		public function PawnDeathHandler():void
		{
		}
		
		protected override function onAdd():void
		{
			super.onAdd();
			owner.eventDispatcher.addEventListener(HealthComponent.DIED, onDied);
		}
		
		protected override function onRemove():void
		{
			owner.eventDispatcher.removeEventListener(HealthComponent.DIED, onDied);
			super.onRemove();
		}
		
		protected function onDied(event:Event):void
		{
			var position:Point = owner.getProperty(PositionReference);
			//If its an AI Mover do this
			if ( owner.doesPropertyExist(new PropertyReference("@AIMover.isDead")) )
			{
				owner.setProperty(new PropertyReference("@AIMover.isDead"), true);
				owner.setProperty(new PropertyReference("@AIMover.animation"), "death");
			}
			//If its an AI Jumper do this
			if ( owner.doesPropertyExist(new PropertyReference("@AIJumper.isDead")) )
			{
				owner.setProperty(new PropertyReference("@AIJumper.isDead"), true);
				owner.setProperty(new PropertyReference("@AIJumper.animation"), "death");
			}
			//If its an AI Master do this
			if ( owner.doesPropertyExist(new PropertyReference("@AIMaster.isDead")) )
			{
				owner.setProperty(new PropertyReference("@AIMaster.isDead"), true);
				owner.setProperty(new PropertyReference("@AIMaster.animation"), "death");
				PawnKeyboardController.inMenu = true;
				PBE.processManager.schedule(5000, this, Main.nextLevel);
			}
			
			owner.eventDispatcher.dispatchEvent(new Event("enemyAnimation"));
			
			var suicide:ThinkingComponent = owner.lookupComponentByName("Suicide") as ThinkingComponent;
			//If its an AI Master do 5 seconds for little pawns do 2 seconds
			if ( owner.doesPropertyExist(new PropertyReference("@AIMaster.isDead")) )
			{
				suicide.think( owner.destroy, 5000);
			}
			else
			{
				suicide.think( owner.destroy, 2000);
			}
			
			PBE.soundManager.play( "../assets/media/Death.mp3", "inGameSounds" );
		}
	}
}