﻿package  
{
	import com.pblabs.engine.components.TickedComponent;
	import com.pblabs.engine.entity.PropertyReference;
	import com.pblabs.box2D.Box2DManagerComponent;
	import com.pblabs.box2D.CollisionEvent;
	import com.pblabs.engine.PBE;
	import com.pblabs.box2D.Box2DSpatialComponent;
	import com.pblabs.components.basic.HealthComponent;
	
	import flash.events.Event;
	
	import Box2D.Dynamics.b2Body;
	import Box2D.Common.Math.b2Vec2;
	
	/**
	 * ...
	 * @author Jesse James Lord
	 */
	
	public class PawnProjectile extends TickedComponent
	{
		public var Box2DBody:PropertyReference = null;
		public var Box2DManager:PropertyReference = null;
		public var Damage:int = 0;
		
		protected var isPlayer:Boolean = false;
		
		public function PawnProjectile():void
		{
			super();
		}
		
		public override function onTick(tickRate:Number):void
		{
			super.onTick(tickRate);
			
			var body:b2Body = owner.getProperty(Box2DBody);			
			var manager:Box2DManagerComponent = owner.getProperty(Box2DManager);
				
			body.ApplyForce(
				new b2Vec2(-manager.gravity.x * body.m_mass, -manager.gravity.y * body.m_mass),
				new b2Vec2());
		}
		
		protected override function onAdd():void
		{
			super.onAdd();
			owner.eventDispatcher.addEventListener(CollisionEvent.COLLISION_EVENT, OnCollision);		
		}
		
		protected override function onRemove():void
		{	
			owner.eventDispatcher.removeEventListener(CollisionEvent.COLLISION_EVENT, OnCollision);
			super.onRemove();
		}
		
		private function OnCollision(event:CollisionEvent):void
		{
			for each (var collider:Box2DSpatialComponent in [event.collidee, event.collider])
			{
				for each (var otherColliderName:String in ["Enemy", "Platform", "Player"])
				{
					if (PBE.objectTypeManager.doesTypeOverlap(collider.collisionType, otherColliderName))
					{
						owner.destroy();
						
						var health:HealthComponent = collider.owner.lookupComponentByType(HealthComponent) as HealthComponent;
						if (health != null && health.health > 0)
						{
							isPlayer = collider.owner.doesPropertyExist(new PropertyReference("@Input"));
							if ( isPlayer )
							{
								//It is a player:
								PawnKeyboardController.animation = "hit";
								PawnKeyboardController.weaponDelay = 1;
								collider.owner.eventDispatcher.dispatchEvent(new Event("PlayerAnimation"));
							}
							else
							{
								//This is a workaround since apparently I am unable to put a if check without the engine crashing.
								//I am currently at a loss as to a better way to do this.
								//I am just eating these error message at the moment.
								
								//Then its an Enemy AI:
								collider.owner.setProperty(new PropertyReference("@AIMover.animation"), "hit");
								//stun them for a moment
								var count:int = collider.owner.getProperty(new PropertyReference("@AIMover.counter"));
								count -= 25;
								collider.owner.setProperty(new PropertyReference("@AIMover.counterLast"), count );

								collider.owner.setProperty(new PropertyReference("@AIJumper.animation"), "hit");
								//stun them for a moment
								var count1:int = collider.owner.getProperty(new PropertyReference("@AIJumper.counter"));
								count1 -= 25;
								collider.owner.setProperty(new PropertyReference("@AIJumper.counterLast"), count1 );

								collider.owner.eventDispatcher.dispatchEvent(new Event("enemyAnimation"));
							}
							health.damage(Damage);
							PBE.soundManager.play("../assets/media/Pain.mp3", "inGameSounds");
							
						}
						else
							PBE.soundManager.play("../assets/media/BladeClang3.mp3", "inGameSounds");
					}
				}
			}
		}
	}
}