﻿package  
{
	import com.pblabs.engine.resource.ResourceBundle;
	
	/**
	 * ...
	 * @author Jesse James Lord
	 */
	public class PawnResources extends ResourceBundle
	{
		//Resource our menu and game screens
		[Embed(source = "../assets/screens/PWS.jpg", mimeType = "application/octet-stream")]
		public var imgPWS:Class;
		[Embed(source = "../assets/screens/PGS.png", mimeType = "application/octet-stream")]
		public var imgPGS:Class;
		[Embed(source = "../assets/screens/PMM.png", mimeType = "application/octet-stream")]
		public var imgPMM:Class;
		[Embed(source = "../assets/screens/POM.png", mimeType = "application/octet-stream")]
		public var imgPOM:Class;
		[Embed(source = "../assets/screens/PCM.jpg", mimeType = "application/octet-stream")]
		public var imgPCM:Class;
		[Embed(source = "../assets/screens/PHM.jpg", mimeType = "application/octet-stream")]
		public var imgPHS:Class;
		[Embed(source = "../assets/screens/PTS.jpg", mimeType = "application/octet-stream")]
		public var imgPTS:Class;
		[Embed(source = "../assets/screens/PLS.jpg", mimeType = "application/octet-stream")]
		public var imgPLS:Class;
		[Embed(source = "../assets/screens/PLS2.jpg", mimeType = "application/octet-stream")]
		public var imgPLS2:Class;
		[Embed(source = "../assets/screens/PBE.png", mimeType = "application/octet-stream")]
		public var imgPBE:Class;
		[Embed(source = "../assets/screens/credits/PT1.jpg", mimeType = "application/octet-stream")]
		public var imgPT1:Class;
		
		
		//Resource our Pawn Story Boards
		[Embed(source = "../assets/screens/PSB_1.jpg", mimeType = "application/octet-stream")]
		public var imgPSB_1:Class;
		[Embed(source = "../assets/screens/PSB_2.jpg", mimeType = "application/octet-stream")]
		public var imgPSB_2:Class;
		[Embed(source = "../assets/screens/PSB_3.jpg", mimeType = "application/octet-stream")]
		public var imgPSB_3:Class;
		
		//Resource our other images for platforms and portals
		[Embed(source = "../assets/spritesheets/platform.png", mimeType = "application/octet-stream")]
		public var imgPlat:Class;
		[Embed(source = "../assets/spritesheets/PawnPortal.png", mimeType = "application/octet-stream")]
		public var imgPawnPortal:Class;
		
		//Resource our sound and music effects
		[Embed(source='../assets/media/ActionHero.mp3')]
        public var snd1:Class;
        [Embed(source='../assets/media/BladeClang3.mp3')]
        public var snd2:Class;
		[Embed(source='../assets/media/BladeHit4.mp3')]
        public var snd3:Class;
		[Embed(source='../assets/media/BladeSwing3.mp3')]
        public var snd4:Class;
		[Embed(source='../assets/media/DrawWeapon.mp3')]
        public var snd5:Class;
		[Embed(source='../assets/media/Pain.mp3')]
        public var snd6:Class;
		[Embed(source='../assets/media/Death.mp3')]
        public var snd7:Class;
		[Embed(source='../assets/media/Snow.mp3')]
        public var snd8:Class;
		[Embed(source='../assets/media/Faure Pavane For Orchestra Opus 50.mp3')]
        public var snd9:Class;
		
		
		// XML LEVELS
        [Embed(source="../assets/levelDescriptions.xml", mimeType='application/octet-stream')]
        public var lvlDesc:Class;
        [Embed(source="../assets/level1.xml", mimeType='application/octet-stream')]
        public var lvl1:Class;
        [Embed(source="../assets/level2.xml", mimeType='application/octet-stream')]
        public var lvl2:Class;
        [Embed(source="../assets/level3.xml", mimeType='application/octet-stream')]
        public var lvl3:Class;
		
		// XML Templates
		[Embed(source="../assets/backgroundArtTemp.xml", mimeType='application/octet-stream')]
        public var tmpBA:Class;
        [Embed(source="../assets/platformTemp.xml", mimeType='application/octet-stream')]
        public var tmpPla:Class;
        [Embed(source="../assets/playerEnemyTemp.xml", mimeType='application/octet-stream')]
        public var tmpPE:Class;
        [Embed(source="../assets/spriteSheetTemp.xml", mimeType='application/octet-stream')]
        public var tmpSS:Class;
		
		//Sprite Sheets
		[Embed(source = "../assets/spritesheets/shadow.png", mimeType = "application/octet-stream")]
		public var imgPawnShadow:Class;
		[Embed(source = "../assets/spritesheets/SSattackSlash.png", mimeType = "application/octet-stream")]
		public var imgAttackSlash:Class;
		
		//Idle
		[Embed(source="../assets/spritesheets/SSpawnIdle.png", mimeType="application/octet-stream")]
		public var imgPawnIdle:Class;
		[Embed(source="../assets/spritesheets/SSpawnWIdle.png", mimeType="application/octet-stream")]
		public var imgPawnWIdle:Class;
		
		//Move
		[Embed(source="../assets/spritesheets/SSpawnWalk.png", mimeType="application/octet-stream")]
		public var imgPawnMove:Class;
		[Embed(source="../assets/spritesheets/SSpawnWWalk.png", mimeType="application/octet-stream")]
		public var imgPawnWMove:Class;
		
		//Jump
		[Embed(source="../assets/spritesheets/SSpawnJump.png", mimeType="application/octet-stream")]
		public var imgPawnJump:Class;
		[Embed(source="../assets/spritesheets/SSpawnWJump.png", mimeType="application/octet-stream")]
		public var imgPawnWJump:Class;
		
		//Hit
		[Embed(source="../assets/spritesheets/SSpawnHit.png", mimeType="application/octet-stream")]
		public var imgPawnHit:Class;
		[Embed(source="../assets/spritesheets/SSpawnWHit.png", mimeType="application/octet-stream")]
		public var imgPawnWHit:Class;
		
		//Death
		[Embed(source="../assets/spritesheets/SSpawnDeath.png", mimeType="application/octet-stream")]
		public var imgPawnDeath:Class;
		[Embed(source="../assets/spritesheets/SSpawnWDeath.png", mimeType="application/octet-stream")]
		public var imgPawnWDeath:Class;
		
		//attackOne
		[Embed(source="../assets/spritesheets/SSpawnAttack.png", mimeType="application/octet-stream")]
		public var imgPawnAttack:Class;
		[Embed(source="../assets/spritesheets/SSpawnWAttack.png", mimeType="application/octet-stream")]
		public var imgPawnWAttack:Class;
		
		//attackTwo
		//[Embed(source="../assets/spritesheets/SSpawnAttack2Left.png", mimeType="application/octet-stream")]
		//public var PawnAttackTwo:Class;
		
		//Background Level1
		[Embed(source="../assets/level1/level1_clouds.jpg", mimeType="application/octet-stream")]
		public var ImgCloud:Class;
		[Embed(source="../assets/level1/level1_mountain.png", mimeType="application/octet-stream")]
		public var ImgMountain:Class;
		
		[Embed(source="../assets/level1/level1_background_00.png", mimeType="application/octet-stream")]
		public var ImgLevel1:Class;
		[Embed(source="../assets/level1/level1_background_01.png", mimeType="application/octet-stream")]
		public var ImgLevel11:Class;
		[Embed(source="../assets/level1/level1_background_02.png", mimeType="application/octet-stream")]
		public var ImgLevel12:Class;
		[Embed(source="../assets/level1/level1_background_03.png", mimeType="application/octet-stream")]
		public var ImgLevel13:Class;
		[Embed(source="../assets/level1/level1_background_04.png", mimeType="application/octet-stream")]
		public var ImgLevel14:Class;
		[Embed(source="../assets/level1/level1_background_05.png", mimeType="application/octet-stream")]
		public var ImgLevel15:Class;
		[Embed(source="../assets/level1/level1_background_06.png", mimeType="application/octet-stream")]
		public var ImgLevel16:Class;
		[Embed(source="../assets/level1/level1_background_07.png", mimeType="application/octet-stream")]
		public var ImgLevel17:Class;

		[Embed(source="../assets/level1/level1_foreground_00.png", mimeType="application/octet-stream")]
		public var ImgLevel1a:Class;
		[Embed(source="../assets/level1/level1_foreground_01.png", mimeType="application/octet-stream")]
		public var ImgLevel11a:Class;
		[Embed(source="../assets/level1/level1_foreground_02.png", mimeType="application/octet-stream")]
		public var ImgLevel12a:Class;
		[Embed(source="../assets/level1/level1_foreground_03.png", mimeType="application/octet-stream")]
		public var ImgLevel13a:Class;
		[Embed(source="../assets/level1/level1_foreground_04.png", mimeType="application/octet-stream")]
		public var ImgLevel14a:Class;
		[Embed(source="../assets/level1/level1_foreground_05.png", mimeType="application/octet-stream")]
		public var ImgLevel15a:Class;
		[Embed(source="../assets/level1/level1_foreground_06.png", mimeType="application/octet-stream")]
		public var ImgLevel16a:Class;
		[Embed(source="../assets/level1/level1_foreground_07.png", mimeType="application/octet-stream")]
		public var ImgLevel17a:Class;
			
		//level 2:
		[Embed(source="../assets/level2/level2_foreground_00.png", mimeType="application/octet-stream")]
		public var ImgLevel21:Class;
		[Embed(source="../assets/level2/level2_foreground_01.png", mimeType="application/octet-stream")]
		public var ImgLevel22:Class;
		[Embed(source="../assets/level2/level2_foreground_02.png", mimeType="application/octet-stream")]
		public var ImgLevel23:Class;
		[Embed(source="../assets/level2/level2_background_00.png", mimeType="application/octet-stream")]
		public var ImgLevel21a:Class;
		[Embed(source="../assets/level2/level2_background_01.png", mimeType="application/octet-stream")]
		public var ImgLevel22a:Class;
		[Embed(source="../assets/level2/level2_background_02.png", mimeType="application/octet-stream")]
		public var ImgLevel23a:Class;
			//Main Player: Black Knight
		
			//Enemy 1
			
			//Enemy 2
			
			//Enemy 3
			
			//Boss
						
			//Platforms
			
			//Misc
			
			
		//level 3:
			[Embed(source="../assets/level3/level3_background_00.png", mimeType="application/octet-stream")]
			public var ImgLevel31:Class;
			[Embed(source="../assets/level3/level3_background_01.png", mimeType="application/octet-stream")]
			public var ImgLevel32:Class;
			[Embed(source="../assets/level3/level3_background_02.png", mimeType="application/octet-stream")]
			public var ImgLevel33:Class;
			[Embed(source="../assets/level3/level3_background_03.png", mimeType="application/octet-stream")]
			public var ImgLevel34:Class;
			[Embed(source="../assets/level3/level3_background_04.png", mimeType="application/octet-stream")]
			public var ImgLevel35:Class;
			//Main Player: Black Bishop
		
			//Enemy 1
			
			//Enemy 2
			
			//Enemy 3
			
			//Boss
						
			//Platforms
			
			//Misc
		
		//level 4:
			
	}

}