﻿package pawnAIs 
{
	import com.pblabs.engine.components.TickedComponent;
	import com.pblabs.engine.entity.PropertyReference;
	import com.pblabs.engine.components.ThinkingComponent;
	import com.pblabs.engine.PBE;
	import com.pblabs.engine.entity.IEntity;
	
	import flash.events.Event;
	import flash.geom.Point;
	
	/**
	 * ...
	 * @author Jesse James Lord
	 */
	public class PawnAIMaster extends TickedComponent
	{
		private var wait:int = 100;  //about 50 * 32 ~= 1.5 seconds;
		private var distance:Number = 0;
		private var scale:Point;
		private var isIdle:Boolean = false;
		private var facing:Boolean = false;
		
		public var AnimationEventName:String;
		public var animation:String;
		public var counter:int = 0;
		public var counterLast:int = 0;
		public var isDead:Boolean = false;
		
		public function PawnAIMaster():void
		{
			super();
		}
		
		public function get currentAnimation():String
		{
			return animation;
		}
		
		override public function onTick(delta:Number):void
		{
			if ( isDead)
				return;
			if ( PawnKeyboardController.playerPosition )
			{
				var plrPos:Point = PawnKeyboardController.playerPosition;
				counter++;
				if ( counter < counterLast + wait )
					return;
					
				if ( counter % 7 == 0) //157
				{
					var ePos:Point = owner.getProperty(new PropertyReference("@Spatial.position"));
					distance = Point.distance(ePos, plrPos);
					
					//determine which way he is facing:
					if ( plrPos.x > 0 )
					{
						facing = Math.abs(ePos.x) < Math.abs(plrPos.x) ? true : false;
					}
					else if( plrPos.x < 0 )
					{
						facing = Math.abs(ePos.x) < Math.abs(plrPos.x) ? false : true;
					}
					
					//make sure he will look like he is going the correct way
					facing ? scale = new Point( 1.25, 1.25 ) : scale = new Point( -1.25, 1.25 );
					owner.setProperty(new PropertyReference("@Render.scale"), scale);
					
					//If he is close do a normal attack toward the player
					if ( distance < 200 )
					{
						//Schedule the Attack Bullets
						PBE.processManager.schedule(500, this, enemyAttack, ePos.subtract(new Point(0, -50)), facing, 20 );	
						PBE.processManager.schedule(500, this, enemyAttack, ePos.subtract(new Point(0, 0)), facing, 20 );
						PBE.processManager.schedule(500, this, enemyAttack, ePos.subtract(new Point(0, 50)), facing, 20 );	
						
						//Play the attack animation
						animation = "attack";
						owner.eventDispatcher.dispatchEvent(new Event(AnimationEventName));
						counterLast = counter;
						isIdle = true;
					}
					else if ( distance < 275 )
					{
						var velocity:Point = owner.getProperty(new PropertyReference("@Spatial.linearVelocity"));
						
						var ran:Number = Math.round(Math.random() * (2 - 0) + 0);
						if (ran == 1)
						{
							//Jump up
							velocity.y -= 500;
							animation = "jump";
							//Jump left or right
							facing ? velocity.x += 600 : velocity.x -= 600;
						}
						else if( ran == 0)
						{
							//Dash forward
							animation = "walk";
							//Dash left or right
							facing ? velocity.x += 600 : velocity.x -= 600;
						}
						else if ( ran == 2)
						{
							//Spawn enemy unit to engage the PAWN
							animation = "idle";
							
							var ThisNewB:IEntity = PBE.makeEntity("enemyJumper", 
							{
								"@Spatial.position": facing? ePos.subtract(new Point(-50, 0)):ePos.subtract(new Point(50, 0)),
								"@EnemyHealth.maxHealth": 50,
								"@Spatial.linearVelocity": facing?new Point(600, -50):new Point(-600, -50),
								"@Render.scale":facing?new Point( 0.5, 0.5):new Point(-0.5, 0.5),
								"@Render.alpha": 0.5
							});
							
							var suicide2:ThinkingComponent = ThisNewB.lookupComponentByName("Suicide") as ThinkingComponent;
								suicide2.think(ThisNewB.destroy, 10000);
						}
						
						//Play the animation associated with the action
						
						owner.eventDispatcher.dispatchEvent(new Event(AnimationEventName));
						
						owner.setProperty(new PropertyReference("@Spatial.linearVelocity"), velocity);
						counterLast = counter;
						isIdle = true;
					}
					else
					{
						if (isIdle)
						{
							animation = "idle";
							owner.eventDispatcher.dispatchEvent(new Event(AnimationEventName));
							isIdle = false;
						}
					}
				}
			}
		}
		
		private function enemyAttack( position:Point, facing:Boolean, damage:int) : void
		{
			var ThisNew2:IEntity = PBE.makeEntity("enemyWeaponFireball", 
						{
							"@Spatial.size":new Point(20,20),
							"@Spatial.position": position,
							"@Spatial.linearVelocity": facing?new Point(800, -10):new Point(-800, -10),
							"@fireyBullet.Damage": damage,
							"@Render.scale":facing?new Point( -1, 1):new Point(1, 1),
							"@Render.alpha": 0.25
						});
								
			var suicide2:ThinkingComponent = ThisNew2.lookupComponentByName("Suicide") as ThinkingComponent;
				suicide2.think(ThisNew2.destroy, 250);
			return;
		}
	}
}