﻿package  pawnAIs
{
	import com.pblabs.engine.components.TickedComponent;
	import com.pblabs.engine.entity.PropertyReference;
	import com.pblabs.rendering2D.ISpatialObject2D;
	import com.pblabs.engine.PBE;
	import com.pblabs.engine.entity.IEntity;
	import com.pblabs.engine.components.ThinkingComponent;
	
	import flash.geom.Point;
	import flash.events.Event;
	
	/**
	 * ...
	 * @author Jesse James Lord
	 */
	public class PawnAIMover extends TickedComponent
	{
		private var wait:int = 50;  //about 50 * 32 ~= 1.5 seconds;
		private var distance:Number = 0;
		private var scale:Point;
		private var isIdle:Boolean = false;
		private var facing:Boolean = false;
		
		public var AnimationEventName:String;
		public var animation:String;
		public var counter:int = 0;
		public var counterLast:int = 0;
		public var isDead:Boolean = false;
		
		public function PawnAIMover():void
		{
			super();
		}
		public function get currentAnimation():String
		{
			return animation;
		}
		
		override public function onTick(delta:Number):void
		{
			if ( PawnKeyboardController.playerPosition )
			{
				if ( isDead)
					return;
					
				var plrPos:Point = PawnKeyboardController.playerPosition;
				counter++;
				if ( counter < counterLast + wait )
					return;
					
				if ( counter % 7 == 0) //157
				{
					var ePos:Point = owner.getProperty(new PropertyReference("@Spatial.position"));
					distance = Point.distance(ePos, plrPos);
					
					//determine which way he is facing:
					if ( plrPos.x > 0 )
					{
						facing = Math.abs(ePos.x) < Math.abs(plrPos.x) ? true : false;
					}
					else if( plrPos.x < 0 )
					{
						facing = Math.abs(ePos.x) < Math.abs(plrPos.x) ? false : true;
					}
					
					//make sure he will look like he is going the correct way
					facing ? scale = new Point( 0.5, 0.5 ) : scale = new Point( -0.5, 0.5 );
					owner.setProperty(new PropertyReference("@Render.scale"), scale);
					
					//If he is close do a normal attack toward the player
					if ( distance < 100 )
					{
						var ThisNewM:IEntity = PBE.makeEntity("enemyWeaponFireball", 
							{
								"@Spatial.position": ePos,
								"@Spatial.linearVelocity": facing?new Point(400, -10):new Point(-400, -10),
								"@fireyBullet.Damage": 10,
								"@Render.scale":facing?new Point( -1, 1):new Point(1, 1),
								"@Render.alpha": 0.25
							});
						var suicideM:ThinkingComponent = ThisNewM.lookupComponentByName("Suicide") as ThinkingComponent;
							suicideM.think(ThisNewM.destroy, 250);
						//attack the player
						animation = "attack";
						owner.eventDispatcher.dispatchEvent(new Event(AnimationEventName));
						counterLast = counter;
						isIdle = true;
					}
					else if ( distance < 225 )
					{
						var velocity:Point = owner.getProperty(new PropertyReference("@Spatial.linearVelocity"));
						
						velocity.y -= 100;
						
						//Jump left or right
						facing ? velocity.x += 400 : velocity.x -= 400;
						
						//Play the animation associated with the action
						animation = "walk";
						owner.eventDispatcher.dispatchEvent(new Event(AnimationEventName));
						
						owner.setProperty(new PropertyReference("@Spatial.linearVelocity"), velocity);
						counterLast = counter;
						isIdle = true;
					}
					else
					{
						if (isIdle)
						{
							animation = "idle";
							owner.eventDispatcher.dispatchEvent(new Event(AnimationEventName));
							isIdle = false;
						}
					}
				}
			}
		}
	}
}