package pawnParticles
{
	import com.pblabs.rendering2D.DisplayObjectRenderer;
	import com.pblabs.engine.PBE;
	
	import org.flintparticles.twoD.renderers.BitmapRenderer;
	import org.flintparticles.twoD.actions.Explosion;
	
	import flash.events.MouseEvent;
	import flash.display.Sprite;
	import flash.geom.Rectangle;
	import flash.geom.Point;
	
	/**
	 * ...
	 * @author Jesse James Lord
	 */
	public class FlintBitmapRenderer extends DisplayObjectRenderer
	{
		private   var renderer:BitmapRenderer;
		protected var emitters:Array = new Array();

		public function get sprite():Sprite
		{
			return renderer as Sprite;
		}
		
		public function FlintBitmapRenderer(width:int, height:int):void
		{
			super();
			
			//create half the height and width
			var xPoint:int = new int;
			xPoint = (width / 2) * -1;
			var yPoint:int = new int;
			yPoint = (height / 2) * -1;
			
			// create the bitmap renderer object
			renderer = new BitmapRenderer( new Rectangle( xPoint, yPoint, width, height ) );
			  
			// add emitters to the emitters:Array
			addEmitters();
			
			// for all of the present render scenes add the following emitters in the array.
			for (var i:int = 0; i < emitters.length; i++)
			{
			    renderer.addEmitter( emitters[i] );
			}	
			
			this.displayObject = renderer;						
		}
		
		protected function addEmitters():void
		{
		}
		
		override protected function onAdd():void
		{
			super.onAdd();
			PBE.mainStage.addEventListener(MouseEvent.CLICK, coordinates);
		}
		
		override protected function onRemove():void
		{
			PBE.mainStage.removeEventListener(MouseEvent.CLICK, coordinates);
			super.onRemove();
		}

		protected function coordinates(mouseClick:MouseEvent):void
		{
			var p:Point = renderer.globalToLocal( new Point( mouseClick.stageX, mouseClick.stageY ) );
			for (var i:int = 0; i < emitters.length; i++ )
			{
				emitters[i].addAction( new Explosion( 0.5, p.x, p.y, 1000, 10, 1 ) );
			}
		}
	}
}