
package pawnParticles
{
	import org.flintparticles.common.initializers.ImageClass;
	import org.flintparticles.twoD.emitters.Emitter2D;
	import org.flintparticles.common.counters.Steady;
	import org.flintparticles.common.displayObjects.Line;
	import org.flintparticles.twoD.zones.LineZone;
	import org.flintparticles.twoD.zones.PointZone;
	import org.flintparticles.twoD.actions.Move;
	import org.flintparticles.twoD.actions.DeathZone;
	import org.flintparticles.twoD.zones.RectangleZone;
	import org.flintparticles.twoD.actions.RotateToDirection;
	import org.flintparticles.common.initializers.AlphaInit;
	import org.flintparticles.twoD.initializers.Velocity;
	import org.flintparticles.twoD.initializers.Position;

	import flash.geom.Point;
		
	/**
	 * ...
	 * @author Jesse James Lord
	 */
	public class PawnRain extends Emitter2D
	{
		public function PawnRain():void
		{
			counter = new Steady( 10 );
			//Making a rain type emitter that is just water dripping from the ceiling of level 2.
			addInitializer( new ImageClass( Line, 10 ) );
			addInitializer( new Position( new LineZone( new Point( -400, -300 ), new Point( 400, -300 ) ) ) );
			addInitializer( new Velocity( new PointZone( new Point( 0, 300 ) ) ) );
			addInitializer( new AlphaInit( 0.25, 0.5 ) );
			
			addAction( new Move() );
			addAction( new DeathZone( new RectangleZone( -400, -300, 400, 300 ), true ) );
			addAction( new RotateToDirection() );
		}
	}
}