package pawnParticles
{
	import org.flintparticles.twoD.emitters.Emitter2D;
	import org.flintparticles.common.counters.Steady;
	import org.flintparticles.common.initializers.ImageClass;
	import org.flintparticles.common.displayObjects.RadialDot;
	import org.flintparticles.twoD.initializers.Position;
	import org.flintparticles.twoD.zones.LineZone;
	import org.flintparticles.twoD.initializers.Velocity;
	import org.flintparticles.twoD.zones.PointZone;
	import org.flintparticles.common.initializers.ScaleImageInit;
	import org.flintparticles.twoD.actions.Move;
	import org.flintparticles.twoD.actions.DeathZone;
	import org.flintparticles.twoD.zones.RectangleZone;
	import org.flintparticles.twoD.actions.RandomDrift;

	import flash.geom.Point;
		
	/**
	 * ...
	 * @author Jesse James Lord
	 */
	public class PawnSnow extends Emitter2D
	{
		public function PawnSnow():void
		{
			counter = new Steady( 5 );
			//Creating a snow looking type emitter of a radial dot two units and making it drift down the screen
			
			addInitializer( new ImageClass( RadialDot, 2 ) );
			addInitializer( new Position( new LineZone( new Point( -400, -300 ), new Point( 400, -300 ) ) ) );
			addInitializer( new Velocity( new PointZone( new Point( 0, 50 ) ) ) );
			addInitializer( new ScaleImageInit( 0.75, 2 ) );

			addAction( new Move() );
			addAction( new DeathZone( new RectangleZone( -400, -300, 400, 300 ), true ) );
			addAction( new RandomDrift( 30, 50 ) );
		}
	}
}