﻿package  
{
    import com.pblabs.rendering2D.spritesheet.SpriteContainerComponent;
	import com.pblabs.rendering2D.DisplayObjectRenderer;
    
    import flash.display.Sprite;
    import flash.geom.Matrix;
    import flash.geom.Point;
	
	/**
	 * ...
	 * @author Jesse James Lord based off of HanClinto's work on repeatingSprites www.hanclinto.com
	 */
	
	public class pawnRepeatingSprite extends DisplayObjectRenderer
	{
		//Something to hold the images
		public var pawnSS:SpriteContainerComponent;
		
		//Something to determine how fast or slow to scroll it
		public var pawnSR:Point = new Point(1,1);
		
		public function pawnRepeatingSprite():void
		{
			//This is so our background sprite waits for everything else to process and processes last giving it a smooth transitional look
			updatePriority = -1;
		}
		
		override public function onFrame(elapsed:Number):void
		{
            if (!pawnSS || !pawnSS.isLoaded)
                return;
				
			if(!displayObject)
                displayObject = new Sprite();
			
			updateProperties();
			
			if (_transformDirty)
				updateTransform();
				
			var theSprite:Sprite = displayObject as Sprite;

            var theMatrix:Matrix = new Matrix();
            theMatrix.translate(scene.sceneViewBounds.left * (1 - pawnSR.x), scene.sceneViewBounds.top * (1 - pawnSR.y));
			
            // Take the determined sprite size and make it match the main view area.
            theSprite.graphics.clear();
            theSprite.graphics.beginBitmapFill(pawnSS.getFrame(0), theMatrix); 
            theSprite.graphics.drawRect(scene.sceneViewBounds.left, scene.sceneViewBounds.top, 
                scene.sceneViewBounds.width, scene.sceneViewBounds.height);
            theSprite.graphics.endFill();
		}
		
		override public function updateTransform(updateProps:Boolean = false):void
		{
			if(!displayObject)
				return;
			
			if(updateProps)
				updateProperties();
			
			displayObject.alpha = _alpha;
			displayObject.blendMode = _blendMode;
			displayObject.visible = (alpha > 0);
			
			_transformDirty = false;
		}	
		override protected function onAdd():void
		{
			super.onAdd();
		}
		override protected function onRemove():void
		{
			super.onRemove();
		}
	}
}