﻿package pawnScreens 
{
	import com.pblabs.screens.ImageScreen;
	import com.pblabs.engine.PBE;
	import com.pblabs.engine.resource.MP3Resource;
	import com.pblabs.rendering2D.ui.PBButton;
	
	import flash.geom.Rectangle;
	import flash.media.Sound;
	import flash.events.MouseEvent;
	
	/**
	 * ...
	 * @author Jesse James Lord
	 */
	public class PawnIntro extends ImageScreen
	{
		public var waiting:Boolean = false;
		public var waitingSound:Boolean = false;
		
		//Add our two buttons
		public var btnPlay:PBButton = new PBButton();
		public var btnHelp:PBButton = new PBButton();
		
		public function PawnIntro():void
		{	
			//This is the ingame Pawn Introduction Title screen the first thing a player sees.
            super("../assets/screens/PTS.jpg");
			
			//Create the button to start playing the game
			addChild(btnPlay);
			btnPlay.extents = new Rectangle(70, 275, 300, 55);
			btnPlay.alpha = 0;
            btnPlay.refresh();
			
			//Create the button to push the Help Menu for player instruction
			addChild(btnHelp);
            btnHelp.extents = new Rectangle(320, 345, 155, 55);
			btnHelp.alpha = 0;
            btnHelp.refresh();
			
			btnPlay.addEventListener(MouseEvent.CLICK, function resume(e:*):void
            {
                nextScreen(null);
            });
			
			btnHelp.addEventListener(MouseEvent.CLICK, function resume(e:*):void
            {
                PBE.screenManager.push("pawnHelp");
            });
		}
		
		private function onIntroMusic( music:MP3Resource):void
		{
			//Play the intro music Mistro!
			PBE.soundManager.play(music, "introMusic");
		}
	
		override public function onTick(delta:Number) : void
        {
			//If the Intro screen, Music and the game has finished loading Let the player continue
			if (waiting && waitingSound)
			{
				var vol:Number = new Number;
				vol = PBE.soundManager.getCategoryVolume("introMusic");
				
				//This gives us a screen fade effect into the main game.
				vol = vol - 0.05;
				this.alpha = vol;

				PBE.soundManager.setCategoryVolume( "introMusic", vol );
					
				if ( vol < 0 )
				{
					//After the volume is 0 or less then zero lets pop the screen so the player can focus on the task at hand
					PBE.soundManager.setCategoryMuted( "introMusic", true );
					PBE.screenManager.pop();
					PBE.soundManager.play( "../assets/media/snow.mp3", "backMusic", 0, 0);

					//reset the defaults
					this.alpha = 1;
					waiting = false;
					waitingSound = false;
					return;
				}
			}
        }
		
		override public function onHide():void
		{
			PBE.resourceManager.unload("../assets/media/actionHero.mp3", MP3Resource);
		}
		
		override public function onFrame(delta:Number) : void
		{
		}
		
		override public function onShow() : void
        {
			PBE.resourceManager.load("../assets/media/actionHero.mp3", MP3Resource, onIntroMusic);
            waiting = true;
        }
			
		protected function nextScreen(e:*):void
        {
            if(!waiting)
                return;
			waitingSound = true;
        }
	}
}