﻿package pawnScreens 
{
	import com.pblabs.screens.ImageScreen;
	import com.pblabs.rendering2D.ui.PBButton;
	import com.pblabs.engine.PBE;
	import com.pblabs.engine.core.InputKey;
	
	import flash.geom.Rectangle;
	import flash.events.MouseEvent;
	
	/**
	 * ...
	 * @author Jesse James Lord
	 */
	public class PawnMenu extends ImageScreen
	{
		public var btnResume:PBButton = new PBButton();
		public var btnAbout:PBButton = new PBButton();
		public var btnCredits:PBButton = new PBButton();
		public var btnQuit:PBButton = new PBButton();
		
		public function PawnMenu():void
		{
			//This is the Pawn Main Menu screen accessible in game. 
			super("../assets/screens/PMM.png");
			
			//Add the menu buttons
			addChild(btnResume);
			btnResume.extents = new Rectangle(295, 100, 200, 70);
			btnResume.alpha = 0;
            btnResume.refresh();
			
			addChild(btnAbout);
            btnAbout.extents = new Rectangle(320, 220, 150, 60);
			btnAbout.alpha = 0;
            btnAbout.refresh();
            
			addChild(btnCredits);
			btnCredits.extents = new Rectangle(320, 290, 150, 60);
			btnCredits.alpha = 0;
            btnCredits.refresh();
			
			addChild(btnQuit);
			btnQuit.extents = new Rectangle(320, 360, 150, 60);
			btnQuit.alpha = 0;
            btnQuit.refresh();
			
			//Add the button event listeners and what they do
            btnResume.addEventListener(MouseEvent.CLICK, function resume(e:*):void
            {
                PBE.screenManager.pop();
            });
			
            btnAbout.addEventListener(MouseEvent.CLICK, function about(e:*):void
            {
                PBE.screenManager.push("pawnOptions");
            });
			
            btnCredits.addEventListener(MouseEvent.CLICK, function credits(e:*):void
            {
                PBE.screenManager.push("pawnCredits");
            });

            btnQuit.addEventListener(MouseEvent.CLICK, function quit(e:*):void
            {
				PBE.screenManager.pop();
                Main.restartGame();
            });
		}
		
		override public function onTick(delta:Number) : void
        {
			if (PBE.isKeyDown(InputKey.ESCAPE))
				PBE.screenManager.pop();
        }
		
		override public function onHide():void
		{
			PawnKeyboardController.inMenu = false;
		}
	}
}